/*
 * CoMETA_stabilize_test.java
 *
 * Created on September 3, 2002, 9:52 AM
 */

/**
 *
 * @author  Mauro Caporuscio
 */
import CoMETA.*;
import siena.*;
import java.util.*;
import java.io.*;

class MessageHandler implements Notifiable{

    CollectedData data;
    public MessageHandler(CollectedData d){
       data = d;
    }
    
    public synchronized void notify(Notification n) throws SienaException {
        
        long received = System.currentTimeMillis();
        long sent = n.getAttribute("time").longValue();
        int id = n.getAttribute("id").intValue();
        
        System.out.print(String.valueOf(id) + " ");
        System.out.print(sent);
        System.out.println(" " + String.valueOf(received));
        
        packetInfo pk = new packetInfo(id, sent, received);
        
       
        data.packets.add(pk);
        
    }
    
    public void notify(Notification[] s) throws SienaException {
    }   
}

class packetInfo implements Comparable{
      int id;
      long sent;
      long received;
      
      
      public packetInfo(int i, long s, long r){
         id = i;
         sent = s;
         received = r;
      }
      
      public int compareTo(Object o) {
          packetInfo x = (packetInfo) o;
         if (id < x.id) return -1;
         if (id == x.id) return 0;
             else return 1;
      }
      
}
class CollectedData{

    TreeSet packets = new TreeSet();
    long moveOut = 0;
    long moveIn = 0;
    static int replications = 0;
    static Vector replicated = new Vector();
}

public class CoMETA_Stabilize_Consumer {
    
    static Vector res = null;
    
    static CollectedData collectedData = new CollectedData();
    
    public static void printVect(Vector v, Notifiable msgh){
       if ((v != null)&&(v.size() != 0))
          {
           while (!v.isEmpty())
               {
                 //String n = (String) v.remove(0);
                 Notification n = (Notification) v.remove(0);
                 //System.out.println(n.toString());
                 try{
                      msgh.notify(n);
                 }catch(Exception e){
                     e.printStackTrace();
                 }
               }
          }   
        else System.out.println("Event's vector is empty!!!");
    }
    
    
    public static void writeDataTo(String fileName, CollectedData data){
        if (data.packets.size()==0) return;
        long start = ((packetInfo) data.packets.first()).sent;
        
        try{
             File f = new File(fileName); 
             if(!f.exists()) f.createNewFile();

             FileWriter fw = new FileWriter(f);
                      
  	     fw.write("MoveOut: " + String.valueOf(data.moveOut - start) + "\n");
             fw.write("MoveIn: " + String.valueOf(data.moveIn - start)+ "\n");
             fw.write("Replicated Events: " + String.valueOf(data.replications)+ "\n");
            
             Iterator r = data.replicated.iterator();
             String rep = "";
             while(r.hasNext())
               {
                   Integer id = (Integer) r.next();
                   rep = rep.concat(id.toString() + ", ");
               }
             fw.write(rep + "\n");
             
             Iterator i = data.packets.iterator();
             int inc = 0;
             while(i.hasNext())
               {
                   packetInfo pk = (packetInfo) i.next();
                   String info = String.valueOf(inc) + " || " + String.valueOf(pk.id) + " " + String.valueOf(pk.sent - start) + " " + String.valueOf(pk.received - start) + "\n";
	           fw.write(info);
                   inc++;
               }

	     fw.flush();
	     fw.close();
        }catch(Exception ex){
            ex.printStackTrace();
        }  
    
    }
    
    /** Creates a new instance of CoMETA_stabilize_test */
    public CoMETA_Stabilize_Consumer() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        String SienaSourceServer = "ka:"+args[0];
        String ProxySourceServer = args[1];
        String SienaDestServer   = "ka:"+args[2];
        String ProxyDestServer   = args[3];
        
        int moPing               = Integer.parseInt(args[4]);
        int QoS                  = Integer.parseInt(args[5]);
        int moDelay              = Integer.parseInt(args[6]);
        int miDelay              = Integer.parseInt(args[7]);
        
        int subsnum              = Integer.parseInt(args[8]);
        int onMovingTime         = Integer.parseInt(args[9]) * 1000;
        
        String resFile           = args[10];
        
        boolean mo  = false;
        boolean qos = false;
        if (moPing  == 1) mo = true;
        if (QoS == 1)     qos = true;
        
        CollectedData collectedData = new CollectedData();

        try {
	    
              MThinClient mclient = new MThinClient(SienaSourceServer);
              mclient.setID("meskall");
              mclient.setProxy(ProxySourceServer);
              
              // add subscriptions
              MessageHandler msgh = new MessageHandler(collectedData);
              for (int i=0; i<subsnum; i++)
                  {
                    Filter filter = new Filter();
                    filter.addConstraint("type","::msk_test");
                    filter.addConstraint("NUM",i);
                    mclient.subscribe(filter, msgh);
                  }
              
              try{
                   System.out.println("!!!ACTIVE!!!");
                   Thread.sleep(onMovingTime / 2);
                   collectedData.moveOut = System.currentTimeMillis();
                   System.out.println(String.valueOf(collectedData.moveOut) + " MoveOut()");
                   if(mclient.moveOut(qos,mo,moDelay))
                      System.out.println("moveOut");
                   else{
                       System.out.println("ERROR: moveOut failed!!");
                       System.exit(1);
                   }
                      //System.out.println("unsubscribing from "+SienaSourceServer);
	              //mclient.unsubscribe(filter, msgh);
            
                      //System.out.println("disconnecting from "+SienaSourceServer);
	              //mclient.shutdown();
                      
                      System.out.println("!!!ON MOVING!!!");
                      Thread.sleep(onMovingTime);
                      
                      //Connection to the new Server
                      mclient = mclient.setServer(SienaDestServer);
                      collectedData.moveIn = System.currentTimeMillis();
                      System.out.println(String.valueOf(collectedData.moveIn) + " moveIn()" );
                      res = mclient.moveIn(ProxyDestServer, ProxySourceServer, qos, miDelay);
                      //res = mclient.moveIn();
                      System.out.println("Moved In");
                      printVect(res, msgh);
                 }
              catch(Exception e){
                   e.printStackTrace();
                   System.exit(1);
                 } 
          
              //System.out.println("unsubscribing");
	      //cons.removeSubscription(sub);
            
              Thread.sleep(onMovingTime / 2);
              System.out.println("shutting down.");
	      mclient.shutdown();
              
              writeDataTo(resFile, collectedData);
              System.exit(0);
             
            
            } catch (Exception ex) {
	      ex.printStackTrace();
	      System.exit(1);
	    }
        
    }
    
}
