/*
 * MConsumer.java
 *
 * Created on August 23, 2002, 8:31 AM
 */

/**
 *
 * @author  Mauro Caporuscio
 */
import siena.*;
import siena.comm.*;
import CoMETA.*;
import java.util.*;

class LocalBuddy implements Notifiable{

    Notifiable notifiable;
    NotifiableInfo notifiableInfo;
    
    public LocalBuddy(Notifiable n, NotifiableInfo info){
        notifiable = n;
        notifiableInfo = info;
    }
    
    synchronized public void notify(Notification n) throws SienaException {
        
        if(notifiableInfo.isMoving()) 
           {
             notifiableInfo.addNotification(n);
             //System.out.println(n.toString() + " is locally stored");
           }  
        else notifiable.notify(n);
        //System.out.println("MThinClient: " + n.toString());

    }
    
    public void notify(Notification[] s) throws SienaException {
    }
    
} 

class NotifiableInfo {
    
     LocalBuddy localBuddy;
     
     Vector filterList;
     Vector notificationList;
     
     boolean movingStatus;
     
     
     public NotifiableInfo(Notifiable n){
     
        filterList = new Vector();
        notificationList = new Vector();
        localBuddy = new LocalBuddy(n, this);
        movingStatus = false;
     }
     
     public Vector getFilters(){
        return filterList;
    }
    
     public void addNotification(Notification n){
        notificationList.addElement(n);
     }
     
     public Vector getNotifications(){
        return notificationList;
     }
     
     public boolean isMoving(){
       return movingStatus;
     }
     
     public void movingON(){
       movingStatus = true;
     }
     
     public void movingOFF(){
       movingStatus = false;
     }
     
     public Notifiable getBuddy(){
       return localBuddy;
     }
     
}

public class MThinClient extends ThinClient {
    
    Sender sender = null;
    String ClientID = null;
    
    HashMap notifiableMap;
    String SienaURL;
    boolean MoveInAck;
    boolean MoveOutAck;
    
    /** Creates a new instance of MConsumer */
    public MThinClient(String server) throws InvalidSenderException{
        super(server);
        SienaURL = server;
        notifiableMap = new HashMap();
    }    
    
    public MThinClient setServer(String server) throws InvalidSenderException{
        MThinClient m   = new MThinClient(server);
        SienaURL        = server;
        m.notifiableMap = new HashMap(this.notifiableMap);
        m.ClientID      = this.ClientID;
        m.sender        = this.sender;
        return m;
    }
        
    public void subscribe_poset(Filter f, Notifiable n) throws SienaException{
        
       Vector filterList = (Vector) notifiableMap.get(n);
       if (filterList != null)
          {
            for(int i=0; i<filterList.size();)
                if(Covering.covers(f, (Filter) filterList.get(i))) 
                     filterList.remove(i); 
                else {
                        if(Covering.covers((Filter) filterList.get(i), f))
                           return;
                        ++i;
                     }
          }
       else {
              filterList = new Vector();
              notifiableMap.put(n,filterList);
            }
       
       filterList.addElement(new Filter(f));
       super.subscribe(f, n);
    }
    
    public void subscribe(Filter f, Notifiable n) throws SienaException{
       NotifiableInfo local;
       if (!notifiableMap.containsKey(n))
          { 
            local = new NotifiableInfo(n);
            notifiableMap.put(n, local);
          }  
       else local = (NotifiableInfo) notifiableMap.get(n);  
       
       local.getFilters().addElement(new Filter(f));
       super.subscribe(f, local.getBuddy());
    }
    
    public void unsubscribe(Filter f, Notifiable n) throws SienaException{

       NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n); 
       if (local == null) throw (new SienaException());
       
       Vector filterList = (Vector) local.getFilters();    
       if (filterList == null) throw (new SienaException());
       
       for(int i=0; i<filterList.size();) 
           if (Covering.covers(f, (Filter) filterList.get(i))) 
               filterList.remove(i); 
           else {
                  if(Covering.covers((Filter) filterList.get(i), f))
                     return;
                  ++i;
                }  

       if (filterList.size() == 0) 
               notifiableMap.remove(n);
       super.unsubscribe(f, local.getBuddy());
    }
    
    public void unsubscribe(Notifiable n) throws SienaException{
       NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n); 
       unsubscribe((Filter) null, local.getBuddy());
    }
    
//------------------------------------------------------------------------------
    
    public void setID(String Client_ID){
       ClientID = Client_ID;
    }
    
    public String getID(){
       return ClientID;
    }
    
    public void setProxy(String ProxyAddress) throws Exception{
       if (sender == null) sender = new Sender();
       
       sender.setConnection(ProxyAddress); 
    }
    
    private Vector getAllFilters(){
       Vector filters = new Vector();
       Iterator notifiables = (Iterator) notifiableMap.keySet().iterator();
       while (notifiables.hasNext())
           {
             Notifiable n = (Notifiable) notifiables.next();
             NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n);
             Vector tempf = (Vector) local.getFilters();
             filters.addAll(tempf);
           }
       return filters;
    }
    
    private Vector getAllNotifications(){
       Vector notifications = new Vector();
       Iterator notifiables = (Iterator) notifiableMap.keySet().iterator();
       while (notifiables.hasNext())
           {
             Notifiable n = (Notifiable) notifiables.next();
             NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n);
             Vector tempn = (Vector) local.getNotifications();
             notifications.addAll(tempn);
           }
       return notifications;
    }
//==============================================================================    
    
    public boolean subscribeAll(){
        try{
             Iterator notifiables = (Iterator) notifiableMap.keySet().iterator();
             while (notifiables.hasNext())
                 {
                   Notifiable n = (Notifiable) notifiables.next();  
                   NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n);  
                   Vector tempf = (Vector) local.getFilters();  
                   
                   for(int j=0; j<tempf.size(); j++)
                       {
                         Filter f = (Filter) tempf.get(j);
                         super.subscribe(f, local.getBuddy());
                       }
                 }   
           }
        catch(Exception ex){
             ex.printStackTrace();
             return false;
           }  
        return true;
    }
    
    public boolean unsubscribeAll(){
        try{
             Iterator notifiables = (Iterator) notifiableMap.keySet().iterator();
             while (notifiables.hasNext())
                 {
                   Notifiable n = (Notifiable) notifiables.next();  
                   NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n);
                   
                   Iterator filters = (Iterator) ((Vector) local.getFilters()).iterator();
                   while(filters.hasNext())
                       {
                         Filter f = (Filter) filters.next();
                         super.unsubscribe(f, local.getBuddy());
                       }
                 }   
           }
        catch(Exception ex){
             ex.printStackTrace();
             return false;
           }  
        return true;        
    }
    
    public boolean moveOut(boolean QoS, boolean ping, int delay) throws Exception{
        
        Vector filterList = getAllFilters();
        if (!sender.send_moveOut_req(ClientID, filterList, QoS, ping, delay))
           return false;
                 
        Iterator notifiables = (Iterator) notifiableMap.keySet().iterator();
        while (notifiables.hasNext())
            {
              Notifiable n = (Notifiable) notifiables.next();  
              NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n);
              local.movingON();
            }
        unsubscribeAll();
        return true;
    }
    
    public Vector moveIn() throws Exception{
        if (!subscribeAll()) throw (new SienaException());
        
        Vector remoteEvents = sender.send_moveIn_req(ClientID);
        
        Iterator notifiables = (Iterator) notifiableMap.keySet().iterator();
        while (notifiables.hasNext())
            {
              Notifiable n = (Notifiable) notifiables.next();  
              NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n);
              local.movingOFF();
            }
        Vector localEvents = getAllNotifications();
        
        return mergeVector(remoteEvents, localEvents);
    }
    
    public Vector moveIn(String new_proxy_address, String from, boolean QoS, long delay){
        Vector remoteEvents = null;
        Vector localEvents = null;
        Filter filter;
        Notifiable action;
        
        try{
             setProxy(new_proxy_address);
             if (!subscribeAll()) return null;
                        
             if(QoS)
               { 
                 MoveInAck = false;
                 filter = new Filter();
                 filter.addConstraint("__TYPE__","__PING_ACK__");
                 filter.addConstraint("__CLIENT_ID__",this.getID());
                 action = new AckCatch(this);
            
                 Notification notif = new Notification();
                 notif.putAttribute("__TYPE__", "__ACK_REQUEST__");
                 notif.putAttribute("__CLIENT_ID__", this.getID());
                 
                 subscribe(filter, action);
                 System.out.println("waiting for "+ filter.toString());
                 
                 while(!MoveInAck){ 
		   publish(notif);
                   System.out.println("published "+ notif.toString());

		   Thread.sleep(500);
		 }
                           
                 unsubscribe(filter,action);
                 if(!MoveInAck) return null;
               }
             
             Thread.sleep(delay);
             
             remoteEvents = sender.send_downloadEvents_req(ClientID, from);
             
             Iterator notifiables = (Iterator) notifiableMap.keySet().iterator();
             while (notifiables.hasNext())
                   {
                     Notifiable n = (Notifiable) notifiables.next();  
                     NotifiableInfo local = (NotifiableInfo) notifiableMap.get(n);
                     local.movingOFF();
                   }
             localEvents = getAllNotifications();
             remoteEvents = mergeVector(remoteEvents, localEvents);
           }
        catch(Exception e){
            e.printStackTrace();
           }
        return remoteEvents;
    }
    
    private Vector mergeVector(Vector remote_events, Vector local_events){
        
        if ( (remote_events == null) && (local_events == null)) return null;
        
        if (remote_events == null) return local_events;
        if (local_events == null) return remote_events;
        
        int r = 0;
        
        for(int i = 0; i < remote_events.size(); i++)       
           {
             String remote = ((Notification) remote_events.get(i)).toString();
             
             for(int j = 0; j < local_events.size();)
                {
                  String local = ((Notification) local_events.get(j)).toString();
                    
                  if (remote.compareTo(local) == 0) 
                    { 
                        Notification n = (Notification) local_events.remove(j);
                        int id = n.getAttribute("id").intValue();
                        CollectedData.replicated.addElement(new Integer(id));
                        r++;
                    }    
                  else j++;
                }           
           }
        remote_events.addAll(local_events);
        CollectedData.replications = r;
        
        return remote_events;
    }
}

