/*
 * CoMETA_stabilize_test.java
 *
 * Created on September 3, 2002, 9:52 AM
 */

/**
 *
 * @author  Mauro Caporuscio
 */

import siena.*;
import java.util.*;
import java.io.*;

class MessageHandlerN implements Notifiable{

    CollectedDataN data;
    public MessageHandlerN(CollectedDataN d){
       data = d;
    }
    
    public synchronized void notify(Notification n) throws SienaException {
        
        long received = System.currentTimeMillis();
        long sent = n.getAttribute("time").longValue();
        int id = n.getAttribute("id").intValue();
        
        System.out.print(String.valueOf(id) + " ");
        System.out.print(sent);
        System.out.println(" " + String.valueOf(received));
        
        packetInfoN pk = new packetInfoN(id, sent, received);
        
       
        data.packets.add(pk);
        
    }
    
    public void notify(Notification[] s) throws SienaException {
    }   
}

class packetInfoN implements Comparable{
      int id;
      long sent;
      long received;
      
      
      public packetInfoN(int i, long s, long r){
         id = i;
         sent = s;
         received = r;
      }
      
      public int compareTo(Object o) {
          packetInfoN x = (packetInfoN) o;
         if (id < x.id) return -1;
         if (id == x.id) return 0;
             else return 1;
      }
      
}
class CollectedDataN{

    TreeSet packets = new TreeSet();
    long moveOut = 0;
    long moveIn = 0;
    static int replications = 0;
    static Vector replicated = new Vector();
}

public class Naive_Stabilize_Consumer {
    
    static Vector res = null;
    
    static CollectedDataN collectedData = new CollectedDataN();

    static ThinClient mclient = null;
    
    public static void printVect(Vector v, Notifiable msgh){
       if ((v != null)&&(v.size() != 0))
          {
           while (!v.isEmpty())
               {
                 
                 Notification n = (Notification) v.remove(0);
                 
                 try{
                      msgh.notify(n);
                 }catch(Exception e){
                     e.printStackTrace();
                 }
               }
          }   
        else System.out.println("Event's vector is empty!!!");
    }
    
    
    public static void writeDataTo(String fileName, CollectedDataN data){
        if (data.packets.size()==0) return;
        long start = ((packetInfoN) data.packets.first()).sent;
        
        try{
             File f = new File(fileName); 
             if(!f.exists()) f.createNewFile();

             FileWriter fw = new FileWriter(f);
                      
  	     fw.write("MoveOut: " + String.valueOf(data.moveOut - start) + "\n");
             fw.write("MoveIn: " + String.valueOf(data.moveIn - start)+ "\n");
             fw.write("Replicated Events: " + String.valueOf(data.replications)+ "\n");
            
             Iterator r = data.replicated.iterator();
             String rep = "";
             while(r.hasNext())
               {
                   Integer id = (Integer) r.next();
                   rep = rep.concat(id.toString() + ", ");
               }
             fw.write(rep + "\n");
             
             Iterator i = data.packets.iterator();
             int inc = 0;
             while(i.hasNext())
               {
                   packetInfoN pk = (packetInfoN) i.next();
                   String info = String.valueOf(inc) + " || " + String.valueOf(pk.id) + " " + String.valueOf(pk.sent - start) + " " + String.valueOf(pk.received - start) + "\n";
	           fw.write(info);
                   inc++;
               }

	     fw.flush();
	     fw.close();
        }catch(Exception ex){
            ex.printStackTrace();
        }  
    
    }
    

    public static void subscribe_filters(Notifiable msgh, int num) throws Exception{
       for (int i=0; i<num; i++)
           {
             Filter filter = new Filter();
             filter.addConstraint("type","::msk_test");
             filter.addConstraint("NUM",i);
             mclient.subscribe(filter, msgh);
           }
    }

    /** Creates a new instance of Naive_stabilize_test */
    public Naive_Stabilize_Consumer() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        String SienaSourceServer = "ka:"+args[0];
        String SienaDestServer   = "ka:"+args[1];
  
        int subsnum              = Integer.parseInt(args[2]);
        int onMovingTime         = Integer.parseInt(args[3]) * 1000;
        
        String resFile           = args[4];
              
        CollectedDataN collectedDataN = new CollectedDataN();

        try {
	    
              mclient = new ThinClient(SienaSourceServer);
              
              // add subscriptions
              MessageHandlerN msgh = new MessageHandlerN(collectedData);
              subscribe_filters(msgh, subsnum);

              System.out.println("!!!ACTIVE!!!");
              Thread.sleep(onMovingTime);
              collectedData.moveOut = System.currentTimeMillis();
              System.out.println(String.valueOf(collectedData.moveOut) + " MoveOut()");

              mclient.shutdown();
              System.out.println("moveOut");
                   
                      
              System.out.println("!!!ON MOVING!!!");
              Thread.sleep(onMovingTime);
                      
              //Connection to the new Server
              mclient = new ThinClient(SienaDestServer);
              collectedData.moveIn = System.currentTimeMillis();
              System.out.println(String.valueOf(collectedData.moveIn) + " moveIn()" );
	      subscribe_filters(msgh, subsnum);
        
              System.out.println("Moved In");
              printVect(res, msgh);
          
            
              Thread.sleep(onMovingTime);
              System.out.println("shutting down.");
	      mclient.shutdown();
              
              writeDataTo(resFile, collectedData);
              System.exit(0);
             
            
            } catch (Exception ex) {
	      ex.printStackTrace();
	      System.exit(1);
	    }
        
    }
    
}
