/*
 * listener.java
 *
 * Created on November 8, 2002, 11:27 AM
 */

/**
 *
 * @author  Administrator
 */
package CoMETA;

import java.net.*;
import java.io.*;
import java.util.*;

public class Listener implements Runnable{
    
    private ServerSocket serverSocket = null;
    private InetAddress address = null;
    private int port = 0;
    
    private ObjectInputStream  input = null; 
    private ObjectOutputStream output = null; 
    
    private ProxyToClient proxyToClient;
    private ProxyToProxy proxyToProxy;


    private void sendVector(Vector v) throws Exception{
      //FileOutputStream fos = new FileOutputStream("log.tmp");
      //ObjectOutputStream log = new ObjectOutputStream(fos);

       int size = v.size();
       output.writeInt(size);
       output.flush();

       //log.writeInt(size);
       //log.flush();
                            
       for(int i=0; i<size; i++){
         Object obj = v.get(i);
         output.writeObject(obj);
         output.flush();

         //log.writeObject(obj);
         //log.flush();

         //System.out.print(i);
       } 
                            
       output.flush();
    }

    private Vector receiveVector() throws Exception{
        Vector res = new Vector();
        int size = input.readInt();
        for(int i=0; i<size; i++){
	Object obj = input.readObject();
	res.addElement(obj);
        }
        return res;
    }
    
    /** Creates a new instance of listener */
    public Listener(String host, ProxyToClient p2c, ProxyToProxy p2p) {
        
        try{
             int pos = host.indexOf(":");
             port = Integer.parseInt(host.substring(pos+1));
             
             address = InetAddress.getByName(host.substring(0,pos));
             
             serverSocket = new ServerSocket(port, 0, address);
             
             proxyToClient = p2c;
             proxyToProxy  = p2p;
             
        }catch(Exception ex){
             ex.printStackTrace();
        } 
    }
    
    /**
     * @param args the command line arguments
     */
    public void run() {
        
        try{
             while(true){
                Socket socket = serverSocket.accept();
                input    = new ObjectInputStream(socket.getInputStream()); 
                output   = new ObjectOutputStream(socket.getOutputStream()); 
                int type = input.readInt();
                switch (type) {
                  case 0:{  //MoveOut
                            String client_id = input.readUTF();
                            Vector filterlist = receiveVector();
                            boolean QoS  = input.readBoolean();
                            boolean ping = input.readBoolean();
                            long delay   = input.readLong();
                            
                            boolean res = proxyToClient.moveOut(client_id, filterlist, QoS, ping, delay);
                            
                            output.writeBoolean(res);
                            output.flush();
                            break;
                  }
                  
                  case 1:{  //MoveIn
                            String client_id = input.readUTF();
                            Vector res = proxyToClient.moveIn(client_id);
                            
                            sendVector(res);
                            output.flush();
                            break;
                  } 
                  
                  case 2:{  //Download
                            String client_id = input.readUTF();
                            String from = input.readUTF();
                            Vector res = proxyToClient.downloadEvents(client_id, from);


		     sendVector(res);
                            break;
                  } 

//------------------------------------------------------------------------------                  
                  
                  case 3:{  //GetEvents
                            String client_id = input.readUTF();
                            Vector res = proxyToProxy.getEvents(client_id);
                            
		     sendVector(res);                            
                            break;
                  } 
                  
                  case 4:{  //removeClient
                            String client_id = input.readUTF();
                            proxyToProxy.removeClient(client_id);
                            output.writeBoolean(true);
                            output.flush();
                            break;
                  } 
                }      
             }
             
        }catch(Exception ex){
             ex.printStackTrace();
        }
    }
}
