/*
 * sender.java
 *
 * Created on November 8, 2002, 11:27 AM
 */

/**
 *
 * @author  Administrator
 */
package CoMETA;

import java.net.*;
import java.io.*;
import java.util.*;

public class Sender {
    
    private Socket socket = null;
    private InetAddress address = null;
    private int port = 0;
    
    private ObjectInputStream  input = null; 
    private ObjectOutputStream output = null; 
    private ObjectOutputStream log = null; 
    
    /** Creates a new instance of sender */
    public Sender(String host) throws Exception{
        
        setConnection(host);
    }
    
    public Sender(){
    }
    
    private void sendVector(Vector v) throws Exception{
      //FileOutputStream fos = new FileOutputStream("log.tmp");
      //ObjectOutputStream log = new ObjectOutputStream(fos);

       int size = v.size();
       output.writeInt(size);
       output.flush();

       //log.writeInt(size);
       //log.flush();
                            
       for(int i=0; i<size; i++){
         Object obj = v.get(i);
         output.writeObject(obj);
         output.flush();

         //log.writeObject(obj);
         //log.flush();

         //System.out.print(i);
       } 
                            
       output.flush();
    }

    private Vector receiveVector() throws Exception{
        Vector res = new Vector();
        int size = input.readInt();
        for(int i=0; i<size; i++){
	Object obj = input.readObject();
	res.addElement(obj);
        }
        return res;
    }

    public void setConnection(String host) throws Exception{
        
        int pos = host.indexOf(":");
        port = Integer.parseInt(host.substring(pos+1));
        
        address = InetAddress.getByName(host.substring(0,pos));
    }
    
    private void connect() throws Exception{
        socket = new Socket(address, port);
             
        output = new ObjectOutputStream(socket.getOutputStream()); 
        input = new ObjectInputStream(socket.getInputStream()); 
    }
    
    private void close() throws Exception{
        socket.close();
        output = null;
        input  = null;
    }
    
    public boolean send_moveOut_req(String client_id, Vector filterlist, boolean QoS, boolean ping, long delay) throws Exception{
        
        connect();
        
        //type 
        output.writeInt(0);  
        
        //parameters
        output.writeUTF(client_id);
        sendVector(filterlist);
        output.writeBoolean(QoS);
        output.writeBoolean(ping);
        output.writeLong(delay);
        
        output.flush();
        
        boolean res = input.readBoolean();
        
        close();
        return res;
    }
    
    public Vector send_moveIn_req(String client_id) throws Exception{
        
        connect();
        
        output.writeInt(1);
        output.writeUTF(client_id);
        output.flush();
        
        Vector res = receiveVector();
        
        close();
        return res;
    }
    
    public Vector send_downloadEvents_req(String client_id, String from) throws Exception{
        
        connect();
        
        output.writeInt(2);
        output.writeUTF(client_id);
        output.writeUTF(from);
        output.flush();
         
        Vector res = receiveVector(); 

        close();
        return res;
    }
    
    public Vector send_getEvents_req(String client_id) throws Exception{
        
        connect();
        
        output.writeInt(3);
        output.writeUTF(client_id);
        output.flush();
        
        Vector res = receiveVector();
        
        close();
        return res;
    }
    
    public boolean send_removeClient_req(String client_id) throws Exception{
        
        connect();
        
        output.writeInt(4);
        output.writeUTF(client_id);
        output.flush();
        
        boolean res = input.readBoolean();
        
        close();
        return res;
    }
    
}
