#! /bin/sh
#
JAVA=/usr/java/j2sdk1.4.0/bin/java
pwd=`pwd`

server1=128.138.242.72
server2=128.138.242.76
server3=pshe.cs.colorado.edu
#
#
#Configuration Parameters
#
pdelays='1000 500 200 100'
subs='10 50 100'
latency=30
pubs=5000
runs="sw"
#
jar=siena-1.4.3b8.jar:.
#
consumer=Naive_Stabilize_Consumer
producer=CoMETA_Stabilize_Producer
#
port=12345
#
trap test_interrupted 1 2 13 15
test_interrupted () {
    echo "TEST INTERRUPTED" 
    kill $ppid $cpid
    exit 1
}
#

CONSUMER="$JAVA -classpath $jar $consumer $server1:$port $server2:$port"
#
PRODUCER="$JAVA -classpath $jar $producer $server3:$port"
#
fname () {
    echo "s$1_p$2"
}
#
#
for pr in $pdelays
  do
  for s in $subs
    do
    f=`fname $s $pr`
    for r in $runs
      do
      test -f "../naiveRes/${f}_r$r" && continue
      echo starting "${f}_r$r"
      $CONSUMER $s $latency "../naiveRes/${f}_r$r" &
      cpid=$!
      sleep 10
      $PRODUCER $pubs $s $pr &
      ppid=$!
      wait $cpid
      kill $ppid
      wait $ppid
    done
  done
done